JavaRef subclass:#JavaFieldref
	instanceVariableNames:'offset type'
	classVariableNames:'T_LONG T_DOUBLE'
	poolDictionaries:''
	category:'Java-Reader-Support'
!


!JavaFieldref class methodsFor:'initialization'!

initialize
    T_LONG := 1.
    T_DOUBLE := 2.

    "
     self initialize
    "

    "Created: / 10.1.1998 / 11:45:00 / cg"
! !

!JavaFieldref methodsFor:'accessing'!

nameandType
    ^ nameandType

    "Created: 19.8.1997 / 13:54:35 / cg"
!

nameandType:aJavaNameandType
    nameandType := aJavaNameandType

    "Created: 19.8.1997 / 14:01:27 / cg"
! !

!JavaFieldref methodsFor:'printing & storing'!

displayString
    class isNil ifTrue:[
	^ 'JavaFieldRef ( ** unknown class ** ''' , nameandType displayString , ''')'
    ].
    ^ 'JavaFieldRef (' , class fullName , ' ' 
			, '''' , nameandType name , '''' , nameandType signature , ')'
! !

!JavaFieldref methodsFor:'resolving'!

isDouble
    type isNil ifTrue:[
        self resolveType
    ].
    ^ type == T_DOUBLE

    "Modified: / 10.1.1998 / 11:51:52 / cg"
!

isLong
    type isNil ifTrue:[
        self resolveType
    ].
    ^ type == T_LONG

    "Modified: / 10.1.1998 / 11:51:36 / cg"
!

name
    ^ nameandType name
!

offset
    offset isNil ifTrue:[
        self resolve.
    ].
    ^ offset.

    "Modified: / 10.1.1998 / 11:48:19 / cg"
!

resolve
    |nm cls|

    class isUnresolved ifTrue:[
        self halt:'unresolved class'.
    ].

    self resolveType.
    nm := nameandType name asSymbol.
    offset := class instVarOffsetOf:nm.

    "Modified: / 10.1.1998 / 11:50:06 / cg"
!

resolveStatic
    |nm cls|

    cls := class javaClass.
    cls ~~ class ifTrue:[
        class := cls.
    ].

    self resolveType.
    nm := nameandType name asSymbol.
    offset := class class instVarOffsetOf:nm.

    "Created: / 2.1.1998 / 17:16:55 / cg"
    "Modified: / 10.1.1998 / 11:50:45 / cg"
!

resolveType
    type := JavaMethod typeFromSignature:(nameandType signature) in:nil.
    type == #long ifTrue:[
        type := T_LONG.
    ] ifFalse:[
        type == #double ifTrue:[
            type := T_DOUBLE
        ]
    ].

    "Created: / 10.1.1998 / 11:49:36 / cg"
!

staticOffset
    offset isNil ifTrue:[
        self resolveStatic.
    ].
    ^ offset.

    "Modified: / 10.1.1998 / 11:47:59 / cg"
!

type
    type isNil ifTrue:[
        self resolveType.
    ].
    type == T_LONG ifTrue:[
        ^ #long.
    ].
    type == T_DOUBLE ifTrue:[
        ^ #double
    ].

    ^ type.

    "Modified: / 10.1.1998 / 11:50:54 / cg"
! !

!JavaFieldref class methodsFor:'documentation'!

version
    ^ '$Header: /home/jv/Projects/SmalltalkX/repositories/cvs/stx/libjava/JavaFieldref.st,v 1.17 1998/01/17 14:43:39 cg Exp $'

! !
JavaFieldref initialize!
