Object subclass:#JavaObject
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Java-Classes'
!


!JavaObject class methodsFor:'misc'!

resolveClassRefs
!

resolveClassRefsIgnoring:setOfClasses
! !

!JavaObject class methodsFor:'smalltalk interface'!

convertJavaObject:val signature:retValSignature
^ val.

    retValSignature = 'void' ifTrue:[
	^ #void
    ].
    retValSignature = 'boolean' ifTrue:[
	val == 0 ifTrue:[^ false].
	^ true
    ].
    retValSignature = 'int' ifTrue:[
	val isInteger ifFalse:[
	    self halt
	].
	^ val
    ].
    retValSignature = 'char[]' ifTrue:[
	"/ these are ST-strings
	^ val
    ].

    retValSignature = 'char' ifTrue:[
	"/ these are ST-characters
	val isInteger ifTrue:[
	    ^ Character value:val
	].
	self halt.
	^ val
    ].

    retValSignature = 'Object' ifTrue:[
	^ val
    ].

    retValSignature = 'String' ifTrue:[
	^ Java as_ST_String:val
    ].

    'no conversion for: ' print. val class name print. ' to: ' print. retValSignature printNL.
    ^ val.

    "Modified: 8.8.1997 / 12:07:23 / cg"
!

javaStringFrom:aString
    "hard-coding internas of java.lang.String here is bad ..."

    self halt.
    ^ Java as_String:aString

    "Modified: 7.8.1997 / 21:17:32 / cg"
!

stringFromJavaString:aJavaString
    "hard-coding internas of java.lang.String here is bad ..."

    self halt.
    ^ Java as_ST_String:aJavaString

    "Modified: 8.8.1997 / 12:07:29 / cg"
! !

!JavaObject methodsFor:'initialization'!

initializeFields:initialValues
    |sz|

    sz := self class instSize.
    1 to:sz do:[:i |
	self instVarAt:i put:(initialValues at:i)
    ]
!

initializeToZero
    |sz|

    sz := self class instSize.
    1 to:sz do:[:i |
	self instVarAt:i put:0
    ]
! !

!JavaObject methodsFor:'interpreter interface'!

invoke:selector interpreter:i sender:aContext
    "send a message, without args"

    |method cls sel|

    method := JavaClass lookupMethod:selector numArgs:0 in:self class static:false.
"/    method := self lookupMethod:selector numArgs:0.
    method notNil ifTrue:[
        ^ method
            valueWithReceiver:self
            arguments:#()
            selector:selector 
            search:nil
            sender:nil

"/        ^ self 
"/            invokeJavaMethod:method 
"/            interpreter:i 
"/            sender:aContext
"/            selector:selector
    ].

    ^ super doesNotUnderstand:(Message selector:selector)

    "
     |stack|

     stack := (Java at:'java/util/Stack') basicNew.
     stack invoke:#'<init>'. 
    "
    "
     |stack|

     stack := (Java at:'java/util/Stack') new.
     stack invoke:#isEmpty. 
    "
    "
     |stack|

     stack := (Java at:'java/util/Stack') new.
     stack invoke:#size. 
    "

    "Modified: / 7.1.1998 / 11:02:13 / cg"
!

invoke:selector interpreter:i sender:aContext with:argument
    "send a message, with 1 argument. 
     TEMPORARY: This method needs more work."

    |sel method cls argClass jSel|

    sel := selector asSymbolIfInterned.
    sel notNil ifTrue:[
	"/
	"/ hard to do - must find a matching method probably
	"/
	(argument isKindOf:JavaObject) ifTrue:[
	    argClass := argument class.
	] ifFalse:[
	    "/
	    "/ map to Java:
	    "/   String -> [c
	    "/
	    (argument isMemberOf:String) ifTrue:[
		jSel := (selector , '([C)V') asSymbolIfInterned.
		jSel notNil ifTrue:[
		    ^ self 
			invoke:jSel 
			interpreter:i 
			sender:aContext 
			with:argument
		]
	    ]
	].

	method := JavaClass lookupMethod:sel numArgs:1 in:self class static:false.
	"/ method := self lookupMethod:sel numArgs:1.
	method notNil ifTrue:[
	    ^ method
		valueWithReceiver:self
		arguments:(Array with:argument)
"/            ^ self 
"/                invokeJavaMethod:method 
"/                interpreter:i 
"/                sender:aContext 
"/                selector:sel
"/                with:argument
	].

"/        cls := self class.
"/        [cls notNil and:[cls ~~ JavaObject]] whileTrue:[
"/            cls methodDictionary keysAndValuesDo:[:sel :aMethod |
"/                aMethod name == sel ifTrue:[
"/                    aMethod numArgs == 1 ifTrue:[
"/                        "/
"/                        "/ this is not completely correct:
"/                        "/ must look for the best type-match,
"/                        "/ (especially: have to look for best match
"/                        "/  over whole superclass chain ...)
"/                        "/ for now take the first with matching number of args
"/                        "/
"/                        ^ self invokeJavaMethod:aMethod with:argument
"/                    ]
"/                ]
"/            ].
"/            cls := cls superclass.
"/        ].
    ].

    ^ super doesNotUnderstand:(Message selector:selector)

    "
     |stack|

     stack := (Java at:'java/util/Stack') new.
     stack invoke:#push with:1. 
    "
    "
     |stack|

     stack := (Java at:'java/util/Stack') new.
     stack invoke:#push with:1. 
     stack invoke:#push with:2. 
     stack invoke:#pop. 
     stack invoke:#pop. 
     stack invoke:#pop. 
    "

    "Modified: / 5.1.1998 / 02:21:22 / cg"
!

invoke:selector interpreter:i sender:aContext with:arg1 with:arg2 
    "send a message, with 2 arguments. 
     TEMPORARY: This method needs more work."

    |sel method cls argClass jSel|

    sel := selector asSymbolIfInterned.
    sel notNil ifTrue:[
	method := JavaClass lookupMethod:sel numArgs:2 in:self class static:false.
	"/ method := self lookupMethod:sel numArgs:2.
	method notNil ifTrue:[
	    ^ method    
		valueWithReceiver:self
		arguments:(Array with:arg1 with:arg2)
"/            ^ self 
"/                invokeJavaMethod:method 
"/                interpreter:i 
"/                sender:aContext
"/                selector:selector
"/                with:arg1 with:arg2
	].
    ].

    ^ super doesNotUnderstand:(Message selector:selector)

    "Modified: / 5.1.1998 / 02:28:34 / cg"
!

invoke:selector interpreter:i sender:aContext with:arg1 with:arg2 with:arg3
    "send a message, with 3 arguments. 
     TEMPORARY: This method needs more work."

    |sel method cls argClass jSel|

    sel := selector asSymbolIfInterned.
    sel notNil ifTrue:[
	method := JavaClass lookupMethod:sel numArgs:3 in:self class static:false.
	"/ method := self lookupMethod:sel numArgs:3.
	method notNil ifTrue:[
	    ^ self 
		invokeJavaMethod:method 
		interpreter:i 
		sender:aContext 
		selector:selector
		with:arg1 with:arg2 with:arg3
	].
    ].

    ^ super doesNotUnderstand:(Message selector:selector)

    "Modified: 17.8.1997 / 18:26:27 / cg"
!

invoke:selector interpreter:i sender:aContext with:arg1 with:arg2 with:arg3 with:arg4
    "send a message, with 4 arguments. 
     TEMPORARY: This method needs more work."

    |sel method cls argClass jSel|

    sel := selector asSymbolIfInterned.
    sel notNil ifTrue:[
	method := JavaClass lookupMethod:sel numArgs:4 in:self class static:false.
	"/ method := self lookupMethod:sel numArgs:4.
	method notNil ifTrue:[
	    ^ self 
		invokeJavaMethod:method 
		interpreter:i
		sender:aContext 
		selector:selector
		with:arg1 with:arg2 with:arg3 with:arg4
	].
    ].

    ^ super doesNotUnderstand:(Message selector:selector)

    "Modified: 17.8.1997 / 18:26:31 / cg"
!

invoke:selector interpreter:i sender:aContext with:arg1 with:arg2 with:arg3 with:arg4 with:arg5
    "send a message, with 5 arguments. 
     TEMPORARY: This method needs more work."

    |sel method cls argClass jSel|

    sel := selector asSymbolIfInterned.
    sel notNil ifTrue:[
        method := JavaClass lookupMethod:sel numArgs:5 in:self class static:false.
        "/ method := self lookupMethod:sel numArgs:5.
        method notNil ifTrue:[
            ^ method    
                valueWithReceiver:self
                arguments:(Array with:arg1 with:arg2 with:arg3 with:arg4 with:arg5)
"/            ^ self 
"/                invokeJavaMethod:method 
"/                interpreter:i 
"/                sender:aContext 
"/                selector:selector
"/                with:arg1 with:arg2 with:arg3 with:arg4 with:arg5
        ].
    ].

    ^ super doesNotUnderstand:(Message selector:selector)

    "Modified: / 6.1.1998 / 18:25:24 / cg"
!

invoke:selector interpreter:i sender:aContext with:arg1 with:arg2 with:arg3 with:arg4 with:arg5 with:arg6
    "send a message, with 6 arguments. 
     TEMPORARY: This method needs more work."

    |sel method cls argClass jSel|

    sel := selector asSymbolIfInterned.
    sel notNil ifTrue:[
	method := JavaClass lookupMethod:sel numArgs:6 in:self class static:false.
	"/ method := self lookupMethod:sel numArgs:6.
	method notNil ifTrue:[
	    ^ self 
		invokeJavaMethod:method 
		interpreter:i 
		sender:aContext 
		selector:selector
		with:arg1 with:arg2 with:arg3 with:arg4 with:arg5 with:arg6
	].
    ].

    ^ super doesNotUnderstand:(Message selector:selector)

    "Created: 7.8.1997 / 20:57:12 / cg"
    "Modified: 17.8.1997 / 18:26:39 / cg"
!

invoke:selector interpreter:i sender:aContext withAll:arguments
    "send a message, with arguments. 
     TEMPORARY: This method needs more work."

    |sel method cls argClass jSel|

    sel := selector asSymbolIfInterned.
    sel notNil ifTrue:[
	method := JavaClass lookupMethod:sel numArgs:arguments size in:self class static:false.
	"/ method := self lookupMethod:sel numArgs:arguments size.
	method notNil ifTrue:[
	    ^ self 
		invokeJavaMethod:method 
		interpreter:i 
		sender:aContext 
		selector:selector
		withAll:arguments
	].
    ].

    ^ super doesNotUnderstand:(Message selector:selector)

    "Modified: 17.8.1997 / 18:26:45 / cg"
! !

!JavaObject methodsFor:'message sending'!

doesNotUnderstand:aMessage
    |args numArgs javaMethod sel|

    args := aMessage arguments.
    numArgs := args size.
    sel := aMessage selector.

    javaMethod := JavaClass lookupMethod:sel numArgs:numArgs in:self class static:false.
    javaMethod notNil ifTrue:[
	^ javaMethod 
	    valueWithReceiver:self 
	    arguments:args
	    selector:sel 
	    search:nil
	    sender:nil
    ].
    ^ super doesNotUnderstand:aMessage

    "Modified: / 6.1.1998 / 17:58:39 / cg"
!

invokeJavaMethod:aJavaMethod interpreter:i sender:s selector:sel
    "invoke a java method, without arguments."

    |val|

    aJavaMethod numArgs ~~ 0 ifTrue:[
	self halt:'argument count'
    ].
    aJavaMethod isStatic ifTrue:[
	self halt:'static function'
    ].

    val := aJavaMethod valueWithReceiver:self arguments:#() selector:sel.
    val notNil ifTrue:[^ val].

    i push:self.

    val := i interpret:aJavaMethod sender:s.

    ^ JavaObject convertJavaObject:val signature:(aJavaMethod retValSignature)

    "Modified: 30.7.1997 / 13:20:29 / cg"
    "Created: 30.7.1997 / 13:37:25 / cg"
!

invokeJavaMethod:aJavaMethod interpreter:i sender:s selector:sel with:arg1
    "invoke a java method, with two arguments.
     CAVEAT: these cannot be long or doubles currently."

    |val|

    aJavaMethod numArgs ~~ 1 ifTrue:[
	self halt:'argument count'
    ].
    aJavaMethod isStatic ifTrue:[
	self halt:'static function'
    ].

    val := aJavaMethod valueWithReceiver:self arguments:(Array with:arg1) selector:sel.
    val notNil ifTrue:[^ val].

    i push:self.
    i push:arg1.

    val := i interpret:aJavaMethod sender:s.

    ^ JavaObject convertJavaObject:val signature:(aJavaMethod retValSignature)

    "Modified: 30.7.1997 / 13:20:35 / cg"
    "Created: 30.7.1997 / 13:41:01 / cg"
!

invokeJavaMethod:aJavaMethod interpreter:i sender:s selector:sel with:arg1 with:arg2
    "invoke a java method, with two arguments.
     CAVEAT: these cannot be long or doubles currently."

    |val|

    aJavaMethod numArgs ~~ 2 ifTrue:[
	self halt:'argument count'
    ].
    aJavaMethod isStatic ifTrue:[
	self halt:'static function'
    ].

    val := aJavaMethod valueWithReceiver:self arguments:(Array with:arg1 with:arg2) selector:sel.
    val notNil ifTrue:[^ val].

    i push:self.
    i push:arg1.
    i push:arg2.

    val := i interpret:aJavaMethod sender:s.

    ^ JavaObject convertJavaObject:val signature:(aJavaMethod retValSignature)

    "Modified: 30.7.1997 / 13:20:35 / cg"
    "Created: 30.7.1997 / 13:36:02 / cg"
!

invokeJavaMethod:aJavaMethod interpreter:i sender:s selector:sel with:arg1 with:arg2 with:arg3 with:arg4
    "invoke a java method, with 4 arguments.
     CAVEAT: these cannot be long or doubles currently."

    |val|

    aJavaMethod numArgs ~~ 4 ifTrue:[
	self halt:'argument count'
    ].
    aJavaMethod isStatic ifTrue:[
	self halt:'static function'
    ].

    val := aJavaMethod valueWithReceiver:self arguments:(Array with:arg1 with:arg2 with:arg3 with:arg4) selector:sel.
    val notNil ifTrue:[^ val].

    i push:self.
    i push:arg1.
    i push:arg2.
    i push:arg3.
    i push:arg4.

    val := i interpret:aJavaMethod sender:s.

    ^ JavaObject convertJavaObject:val signature:(aJavaMethod retValSignature)

    "Modified: 30.7.1997 / 13:20:35 / cg"
    "Created: 6.8.1997 / 02:41:32 / cg"
!

invokeJavaMethod:aJavaMethod interpreter:i sender:s selector:sel with:arg1 with:arg2 with:arg3 with:arg4 with:arg5
    "invoke a java method, with 5 arguments.
     CAVEAT: these cannot be long or doubles currently."

    |val|

    aJavaMethod numArgs ~~ 5 ifTrue:[
	self halt:'argument count'
    ].
    aJavaMethod isStatic ifTrue:[
	self halt:'static function'
    ].

    val := aJavaMethod valueWithReceiver:self arguments:(Array with:arg1 with:arg2 with:arg3 with:arg4 with:arg5) selector:sel.
    val notNil ifTrue:[^ val].

    i push:self.
    i push:arg1.
    i push:arg2.
    i push:arg3.
    i push:arg4.
    i push:arg5.

    val := i interpret:aJavaMethod sender:s.

    ^ JavaObject convertJavaObject:val signature:(aJavaMethod retValSignature)

    "Modified: 30.7.1997 / 13:20:35 / cg"
    "Created: 3.8.1997 / 20:32:03 / cg"
!

invokeJavaMethod:aJavaMethod interpreter:i sender:s selector:sel with:arg1 with:arg2 with:arg3 with:arg4 with:arg5 with:arg6
    "invoke a java method, with 6 arguments.
     CAVEAT: these cannot be long or doubles currently."

    |val|

    aJavaMethod numArgs ~~ 6 ifTrue:[
	self halt:'argument count'
    ].
    aJavaMethod isStatic ifTrue:[
	self halt:'static function'
    ].

    val := aJavaMethod valueWithReceiver:self arguments:(Array with:arg1 with:arg2 with:arg3 with:arg4 with:arg5 with:arg6) selector:sel.
    val notNil ifTrue:[^ val].

    i push:self.
    i push:arg1.
    i push:arg2.
    i push:arg3.
    i push:arg4.
    i push:arg5.
    i push:arg6.

    val := i interpret:aJavaMethod sender:s.

    ^ JavaObject convertJavaObject:val signature:(aJavaMethod retValSignature)

    "Modified: 30.7.1997 / 13:20:35 / cg"
    "Created: 7.8.1997 / 20:57:55 / cg"
!

invokeJavaMethod:aJavaMethod interpreter:i sender:s with:arg1 with:arg2
    "invoke a java method, with two arguments.
     CAVEAT: these cannot be long or doubles currently."

    |val|

    aJavaMethod numArgs ~~ 2 ifTrue:[
	self halt:'argument count'
    ].
    aJavaMethod isStatic ifTrue:[
	self halt:'static function'
    ].

    val := aJavaMethod valueWithReceiver:self arguments:(Array with:arg1 with:arg2).
    val notNil ifTrue:[^ val].

    i push:self.
    i push:arg1.
    i push:arg2.

    val := i interpret:aJavaMethod sender:s.

    ^ JavaObject convertJavaObject:val signature:(aJavaMethod retValSignature)

    "Modified: 30.7.1997 / 13:20:35 / cg"
!

invokeJavaMethod:aJavaMethod interpreter:i sender:s with:arg1 with:arg2 with:arg3
    "invoke a java method, with 3 arguments.
     CAVEAT: these cannot be long or doubles currently."

    |val|

    aJavaMethod numArgs ~~ 3 ifTrue:[
	self halt:'argument count'
    ].
    aJavaMethod isStatic ifTrue:[
	self halt:'static function'
    ].

    val := aJavaMethod valueWithReceiver:self arguments:(Array with:arg1 with:arg2 with:arg3).
    val notNil ifTrue:[^ val].

    i push:self.
    i push:arg1.
    i push:arg2.
    i push:arg3.

    val := i interpret:aJavaMethod sender:s.

    ^ JavaObject convertJavaObject:val signature:(aJavaMethod retValSignature)

    "Modified: 30.7.1997 / 13:20:44 / cg"
!

invokeJavaMethod:aJavaMethod interpreter:i sender:s with:arg1 with:arg2 with:arg3 with:arg4
    "invoke a java method, with 4 arguments.
     CAVEAT: these cannot be long or doubles currently."

    |val|

    aJavaMethod numArgs ~~ 4 ifTrue:[
	self halt:'argument count'
    ].
    aJavaMethod isStatic ifTrue:[
	self halt:'static function'
    ].

    val := aJavaMethod valueWithReceiver:self arguments:(Array with:arg1 with:arg2 with:arg3 with:arg4).
    val notNil ifTrue:[^ val].

    i push:self.
    i push:arg1.
    i push:arg2.
    i push:arg3.
    i push:arg4.

    val := i interpret:aJavaMethod sender:s.

    ^ JavaObject convertJavaObject:val signature:(aJavaMethod retValSignature)

    "Modified: 30.7.1997 / 13:20:51 / cg"
!

invokeJavaMethod:aJavaMethod interpreter:i sender:s withAll:args
    "invoke a java method, with two arguments.
     CAVEAT: these cannot be long or doubles currently."

    |val|

    aJavaMethod numArgs ~~ args size ifTrue:[
	self halt:'argument count'
    ].
    aJavaMethod isStatic ifTrue:[
	self halt:'static function'
    ].

    val := aJavaMethod valueWithReceiver:self arguments:args.
    val notNil ifTrue:[^ val].

    i push:self.
    args do:[:arg |
	i push:arg.
    ].

    val := i interpret:aJavaMethod sender:s.

    ^ JavaObject convertJavaObject:val signature:(aJavaMethod retValSignature)

    "Modified: 30.7.1997 / 13:20:58 / cg"
!

invokeJavaMethod:aJavaMethod with:arg1 with:arg2
    "invoke a java method, with two arguments.
     CAVEAT: these cannot be long or doubles currently."

    ^ self 
	invokeJavaMethod:aJavaMethod 
	interpreter:JavaInterpreter new 
	sender:thisContext sender 
	with:arg1 
	with:arg2

    "Modified: 30.7.1997 / 13:25:36 / cg"
! !

!JavaObject methodsFor:'printing & storing'!

displayString
    self class == Java java_lang_String ifTrue:[
        ^ '''' , (Java as_ST_String:self) , ''''
    ].

    self class == (Java at:'java.lang.Class') ifTrue:[
        ^ super displayString , '(' , (JavaVM classForJavaClassObject:self) displayString , ')'
    ].

    ^ super displayString.

    Object errorSignal handle:[:ex |
        ^ super displayString.
    ] do:[
        ^ Java as_ST_String:(self invoke:#toString).
    ].

    ^ super displayString. "/ ^ 'a JavaObject(' , self class name , ')'

    "Modified: / 4.2.1998 / 12:30:21 / cg"
!

javaDisplayString
    Object errorSignal handle:[:ex |
	ex return.
    ] do:[
	^ Java as_ST_String:(self invoke:#toString).
    ].

    ^ super displayString.

    "Created: 7.4.1997 / 17:38:13 / cg"
    "Modified: 8.8.1997 / 12:07:39 / cg"
! !

!JavaObject methodsFor:'queries'!

isJavaObject
    ^ true

    "Created: 26.3.1997 / 13:34:17 / cg"
! !

!JavaObject methodsFor:'smalltalk interface'!

invoke:selector
    "send a message, without args"

    |method|

    method := JavaClass lookupMethod:selector numArgs:0 in:self class static:false.
    method notNil ifTrue:[
        ^ method
            valueWithReceiver:self
            arguments:#()
            selector:(method selector)
            search:nil
            sender:nil
    ].

    ^ super doesNotUnderstand:(Message selector:selector)      

    "
     |stack|

     stack := (Java at:'java/util/Stack') basicNew.
     stack invoke:#'<init>'. 
    "
    "
     |stack|

     stack := (Java at:'java/util/Stack') new.
     stack invoke:#isEmpty. 
    "
    "
     |stack|

     stack := (Java at:'java/util/Stack') new.
     stack invoke:#size. 
    "

    "Modified: / 7.1.1998 / 14:04:03 / cg"
!

invoke:selector sender:aContext
    "send a message, without args"

    ^ self      
	invoke:selector 
	interpreter:(JavaInterpreter new) 
	sender:aContext

    "Modified: 30.7.1997 / 13:59:18 / cg"
!

invoke:selector with:arg
    "send a message, with 1 argument. 
     TEMPORARY: This method needs more work."

    ^ self 
	invoke:selector 
	interpreter:(JavaInterpreter new) 
	sender:thisContext sender 
	with:arg

    "
     |stack|

     stack := (Java at:'java/util/Stack') new.
     stack invoke:#push with:1. 
    "
    "
     |stack|

     stack := (Java at:'java/util/Stack') new.
     stack invoke:#push with:1. 
     stack invoke:#push with:2. 
     stack invoke:#pop. 
     stack invoke:#pop. 
     stack invoke:#pop. 
    "

    "Modified: 17.8.1997 / 18:07:39 / cg"
!

invoke:selector with:arg1 with:arg2
    "send a message, with 2 argument. 
     TEMPORARY: This method needs more work."

    ^ self 
	invoke:selector 
	interpreter:(JavaInterpreter new) 
	sender:thisContext sender 
	with:arg1
	with:arg2

    "Modified: 17.8.1997 / 18:07:45 / cg"
!

invoke:selector with:arg1 with:arg2 with:arg3
    "send a message, with 3 argument. 
     TEMPORARY: This method needs more work."

    ^ self 
	invoke:selector 
	interpreter:(JavaInterpreter new) 
	sender:thisContext sender 
	with:arg1
	with:arg2
	with:arg3

    "Created: 30.7.1997 / 13:48:24 / cg"
    "Modified: 17.8.1997 / 18:07:48 / cg"
!

invoke:selector with:arg1 with:arg2 with:arg3 with:arg4
    "send a message, with 5 argument. 
     TEMPORARY: This method needs more work."

    ^ self 
	invoke:selector 
	interpreter:(JavaInterpreter new) 
	sender:thisContext sender 
	with:arg1
	with:arg2
	with:arg3
	with:arg4

    "Created: 6.8.1997 / 02:38:44 / cg"
    "Modified: 17.8.1997 / 18:07:52 / cg"
!

invoke:selector with:arg1 with:arg2 with:arg3 with:arg4 with:arg5
    "send a message, with 5 argument. 
     TEMPORARY: This method needs more work."

    ^ self 
	invoke:selector 
	interpreter:(JavaInterpreter new) 
	sender:thisContext sender 
	with:arg1
	with:arg2
	with:arg3
	with:arg4
	with:arg5

    "Created: 3.8.1997 / 20:30:22 / cg"
    "Modified: 17.8.1997 / 18:07:55 / cg"
!

invoke:selector with:arg1 with:arg2 with:arg3 with:arg4 with:arg5 with:arg6
    "send a message, with 6 argument. 
     TEMPORARY: This method needs more work."

    ^ self 
	invoke:selector 
	interpreter:(JavaInterpreter new) 
	sender:thisContext sender 
	with:arg1
	with:arg2
	with:arg3
	with:arg4
	with:arg5
	with:arg6

    "Created: 7.8.1997 / 20:56:49 / cg"
    "Modified: 17.8.1997 / 18:07:58 / cg"
!

invoke:selector withAll:args
    "send a message, with anumber of arguments. 
     TEMPORARY: This method needs more work."

    ^ self 
	invoke:selector 
	interpreter:(JavaInterpreter new) 
	sender:thisContext sender 
	withAll:args

    "Created: 30.7.1997 / 13:56:33 / cg"
    "Modified: 17.8.1997 / 18:08:01 / cg"
!

lookupMethod:selector numArgs:nargs
    "lookup a method"

    |method cls sel|

    sel := selector.
    (sel includes:$:) ifTrue:[
	sel := sel copyTo:(sel indexOf:$:)-1    
    ].

    sel := sel asSymbolIfInterned.
    sel notNil ifTrue:[
	cls := self class.
	[cls notNil and:[cls ~~ JavaObject]] whileTrue:[
	    cls methodDictionary keysAndValuesDo:[:jSel :aMethod |
		(jSel == sel ) ifTrue:[
		    ^ aMethod
		]
	    ].
	    cls methodDictionary keysAndValuesDo:[:jSel :aMethod |
		(aMethod name = sel 
		or:[aMethod signatureNameWithoutReturnType = sel]) ifTrue:[
		    aMethod numArgs == nargs ifTrue:[
			^ aMethod
		    ]
		]
	    ].
	    cls := cls superclass.
	].
    ].

    ^ nil

    "
     |stack|

     stack := (Java at:'java.util.Stack') basicNew.
     stack lookupMethod:#'<init>' numArgs:0. 
    "
    "
     |stack|

     stack := (Java at:'java.util.Stack') new.
     stack lookupMethod:#isEmpty numArgs:0. 
    "
    "
     |frame|

     frame := (Java at:'java.awt.Frame') new.
     frame lookupMethod:#'<init> (String)' numArgs:1. 
    "

    "Modified: 22.3.1997 / 00:56:54 / cg"
! !

!JavaObject class methodsFor:'documentation'!

version
    ^ '$Header: /home/jv/Projects/SmalltalkX/repositories/cvs/stx/libjava/JavaObject.st,v 1.37 1998/02/05 11:03:48 cg Exp $'
! !
