Object subclass:#JavaRef
	instanceVariableNames:'class nameandType'
	classVariableNames:''
	poolDictionaries:''
	category:'Java-Reader-Support'
!


!JavaRef class methodsFor:'instance creation'!

class:aJavaClass nameandType:nameAndType
    ^ self new class:aJavaClass nameandType:nameAndType

    "Created: 15.4.1996 / 16:10:49 / cg"
! !

!JavaRef class methodsFor:'validation'!

validateAll
    self allSubInstancesDo:[:ref |
        ref validateClass
    ]

    "
     self validateAll
    "

    "Created: 20.3.1997 / 00:13:55 / cg"
    "Modified: 20.3.1997 / 00:14:24 / cg"
! !

!JavaRef methodsFor:'accessing'!

class:aJavaClass nameandType:aJavanameAndType
     class := aJavaClass.
     nameandType := aJavanameAndType.
class isNil ifTrue:[self halt].


    "Modified: 15.4.1996 / 16:08:39 / cg"
    "Created: 15.4.1996 / 16:10:37 / cg"
!

javaClass
     ^ class
! !

!JavaRef methodsFor:'printing & storing'!

displayString
    |clsName|

    class isJavaClass ifTrue:[
        clsName := class fullName
    ] ifFalse:[
        clsName := class name
    ].
    ^ self class name , '(class:' , clsName , ' ; name&type: ' , nameandType displayString , ')'

    "Created: 15.4.1996 / 16:18:54 / cg"
    "Modified: 7.4.1997 / 13:43:29 / cg"
! !

!JavaRef methodsFor:'queries'!

isUnresolved
    ^ false


! !

!JavaRef methodsFor:'special'!

updateClassRefsFrom:oldClass to:newClass
    class == oldClass ifTrue:[
        newClass isNil ifTrue:[
            class := JavaUnresolvedClassConstant fullName:(class fullName)
        ] ifFalse:[
            class := newClass
        ]
    ] ifFalse:[
        class isJavaClass ifTrue:[
            class fullName = oldClass fullName ifTrue:[
                'JAVA: class update by name.' infoPrintCR.
                class := newClass
            ]
        ]
    ]

    "Created: / 7.8.1997 / 15:01:09 / cg"
    "Modified: / 4.2.1998 / 22:19:23 / cg"
! !

!JavaRef methodsFor:'validation'!

validateClass
    |actualClass|

    class notNil ifTrue:[
        class isJavaClass ifTrue:[
            class ~~ (actualClass := Java at:(class fullName)) ifTrue:[
                Transcript showCR:'updated ref to: ' , class fullName.
                class := actualClass
            ]
        ]
    ].

    "Created: 20.3.1997 / 00:13:27 / cg"
    "Modified: 20.3.1997 / 00:16:54 / cg"
! !

!JavaRef class methodsFor:'documentation'!

version
    ^ '$Header: /home/jv/Projects/SmalltalkX/repositories/cvs/stx/libjava/JavaRef.st,v 1.13 1998/02/05 11:12:57 cg Exp $'
! !
