View subclass:#JavaView
	instanceVariableNames:'eventReceiver updateRegions javaPeer'
	classVariableNames:''
	poolDictionaries:''
	category:'Java-Views-Support'
!


!JavaView methodsFor:'accessing'!

delegate:anObject
    super delegate:anObject.
    eventReceiver := anObject.

    "Created: 18.8.1997 / 15:22:20 / cg"
!

getNextUpdateRectangle
    |r|

    updateRegions size == 0 ifTrue:[^ nil].
    r := updateRegions removeFirst.
    updateRegions size == 0 ifTrue:[updateRegions := nil].
    ^ r

    "Created: 18.8.1997 / 15:37:31 / cg"
!

javaPeer
    "for debugging support - here is a handle to the corresponding
     javaPeer"

    ^ javaPeer

    "Created: 18.8.1997 / 22:34:35 / cg"
!

javaPeer:aJavaView
    "for debugging support - here is a handle to the corresponding
     javaPeer"

    javaPeer := aJavaView

    "Created: 18.8.1997 / 22:34:30 / cg"
! !

!JavaView methodsFor:'event handling'!

buttonMotion:state x:x y:y
    |ev|

"/ 'JavaView buttonMotion' printCR.

    eventReceiver notNil ifTrue:[
        ev := WindowEvent buttonEvent
                 for:self
                 type:#buttonMotion:x:y:
                 arguments:(Array with:state with:x with:y).
        eventReceiver processEvent:ev.
    ].

    "Created: / 23.8.1997 / 03:13:38 / cg"
    "Modified: / 6.2.1998 / 00:56:52 / cg"
!

buttonPress:button x:x y:y
    |ev|

"/ 'JavaView buttonPress' printCR.

    eventReceiver notNil ifTrue:[
        ev := WindowEvent buttonEvent
                 for:self
                 type:#buttonPress:x:y:
                 arguments:(Array with:button with:x with:y).
        eventReceiver processEvent:ev.
    ].

    "Created: / 21.8.1997 / 19:37:57 / cg"
    "Modified: / 6.2.1998 / 00:56:56 / cg"
!

buttonRelease:button x:x y:y
    |ev|

"/ 'JavaView buttonRelease' printCR.

    eventReceiver notNil ifTrue:[
        ev := WindowEvent buttonEvent
                 for:self
                 type:#buttonRelease:x:y:
                 arguments:(Array with:button with:x with:y).
        eventReceiver processEvent:ev.
    ].

    "Created: / 23.8.1997 / 02:22:23 / cg"
    "Modified: / 6.2.1998 / 00:57:00 / cg"
!

exposeX:x y:y width:w height:h
    |ev|

"/ 'JavaView expose' printCR.

    updateRegions isNil ifTrue:[
        updateRegions := OrderedCollection new.
    ].
    updateRegions add:(Rectangle left:x top:y width:w height:h).
    eventReceiver notNil ifTrue:[
        ev := WindowEvent 
                damageFor:self 
                rectangle:(Rectangle left:x top:y width:w height:h). 
        eventReceiver processEvent:ev.
    ].
    super exposeX:x y:y width:w height:h

    "Created: / 18.8.1997 / 15:00:24 / cg"
    "Modified: / 6.2.1998 / 00:57:04 / cg"
!

keyPress:key x:x y:y
    |ev|

"/ 'JavaView keyPress' printCR.

    eventReceiver notNil ifTrue:[
        ev := WindowEvent keyboardEvent
                 for:self
                 type:#keyPress:x:y:
                 arguments:(Array with:key with:x with:y).
        eventReceiver processEvent:ev.
    ].

    "Created: / 8.1.1998 / 18:01:55 / cg"
    "Modified: / 6.2.1998 / 00:57:08 / cg"
!

keyRelease:key x:x y:y
    |ev|

"/ 'JavaView keyRelease' printCR.

    eventReceiver notNil ifTrue:[
        ev := WindowEvent keyboardEvent
                 for:self
                 type:#keyRelease:x:y:
                 arguments:(Array with:key with:x with:y).
        eventReceiver processEvent:ev.
    ].

    "Created: / 8.1.1998 / 18:02:03 / cg"
    "Modified: / 6.2.1998 / 00:57:16 / cg"
! !

!JavaView methodsFor:'initialization'!

initialize
    super initialize.

    self enableMotionEvents.
    (superView notNil and:[superView isMemberOf:JavaEmbeddedFrameView])
    ifTrue:[
        self viewBackground:superView viewBackground
    ]

    "Created: / 21.8.1997 / 16:37:45 / cg"
    "Modified: / 13.1.1998 / 14:29:30 / cg"
! !

!JavaView class methodsFor:'documentation'!

version
    ^ '$Header: /home/jv/Projects/SmalltalkX/repositories/cvs/stx/libjava/JavaView.st,v 1.11 1998/02/06 00:00:03 cg Exp $'
! !
